;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;        Copyright 2001-2002 The Removers, all rights reserved.
;;         Copying is covered by the GNU General Public License.

;;    This program is free software; you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation; either version 2 of the License, or
;;    (at your option) any later version.

;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;;    GNU General Public License for more details.

	TEXT

aff_init:
	move.l	#interface,a0
	bsr	interface_init
	rts

aff_mnemo:
; d0 : adresse de l'instruction
; a0 : fentre
	move.l	a0,-(sp)
	move.l	#.adress,a0
	move.b	#4,d1
	move.b	#'$',(a0)+
	bsr	convert_to_string
	move.l	(sp),a0
*	move.l	#win_trace,a0
	move.l	#.adress,a1
	bsr	cconws_window
	bsr	tab
	move.l	text,a1
	bsr	cconws_window
	bsr	tab
	bsr.s	cook_operandes
	move.l	(sp)+,a0
*	move.l	#win_trace,a0
	move.l	#operandes,a1
	bsr	clear_on
	bsr	cconws_window
	bsr	clear_off
;	REPT	5
;	bsr	space_tab
;	ENDR
;	move.w	#1,window.column(a0)
;	move.w	#1,window.line(a0)
	bsr	_crlf
	rts
.adress:
	dcb.w	4
	
cook_operandes:
	lea	operandes,a0
	move.b	#9,(a0)+
.dir:
	tst.l	dir
	beq.s	.ext
	move.l	dir,a1
	move.b	#'>',(a0)+
	move.b	#'$',(a0)+
	clr.w	d0
	move.b	(a1),d0
	move.b	#2,d1
	bsr	convert_to_string
	addq.w	#2,a0
	move.b	#9,(a0)+	; TAB
.ext:
	tst.l	ext
	beq.s	.imm_e
	move.l	ext,a1
	move.b	#'$',(a0)+
	move.w	(a1),d0
	move.b	#4,d1
	bsr	convert_to_string
	addq.w	#4,a0
	move.b	#9,(a0)+
.imm_e:
	tst.l	imm_e
	beq.s	.imm_s
	move.l	imm_e,a1
	move.b	#'#',(a0)+
	move.b	#'$',(a0)+
	move.w	(a1),d0
	move.b	#4,d1
	bsr	convert_to_string
	addq.w	#4,a0
	move.b	#9,(a0)+
.imm_s:
	tst.l	imm_s
	beq.s	.ind_x
	move.l	imm_s,a1
	move.b	#'#',(a0)+
	move.b	#'$',(a0)+
	move.b	(a1),d0
	move.b	#2,d1
	bsr	convert_to_string
	addq.w	#2,a0
	move.b	#9,(a0)+
.ind_x:
	tst.l	ind_x
	beq.s	.ind_y
	move.l	ind_x,a1
	move.b	#'$',(a0)+
	move.b	(a1),d0
	move.b	#2,d1
	bsr	convert_to_string
	addq.w	#2,a0
	move.b	#',',(a0)+
	move.b	#'X',(a0)+
	move.b	#9,(a0)+
.ind_y:
	tst.l	ind_y
	beq.s	.mask
	move.l	ind_y,a1
	move.b	#'$',(a0)+
	move.b	(a1),d0
	move.b	#2,d1
	bsr	convert_to_string
	addq.w	#2,a0
	move.b	#',',(a0)+
	move.b	#'Y',(a0)+
	move.b	#9,(a0)+
.mask:
	tst.l	mask
	beq.s	.rel
	move.l	mask,a1
;	move.b	#'#',(a0)+
	move.b	#'$',(a0)+
	move.b	(a1),d0
	move.b	#2,d1
	bsr	convert_to_string
	addq.w	#2,a0
	move.b	#9,(a0)+
.rel:
	tst.l	rel
	beq.s	.no_fields
	move.l	rel,a1
	move.b	#'$',(a0)+
	clr.w	d0
	move.b	(a1),d0
	ext.w	d0
	add.w	_pc,d0
	move.b	#4,d1
	bsr	convert_to_string
	addq.w	#4,a0
	move.b	#9,(a0)+
.no_fields:
	move.b	#' ',(a0)+	; gruge au cas o il n'y a aucun oprande
	clr.b	-(a0)
	rts

aff_regs:
; a0 : fentre
	move.w	#1,window.column(a0)
	move.w	#1,window.line(a0)
	bsr.s	aff_a
	bsr.s	space_tab
	bsr	aff_x
	bsr.s	_crlf
	bsr	aff_b
	bsr.s	space_tab
	bsr	aff_y
	bsr.s	_crlf
	bsr	aff_d
	bsr.s	space_tab
	bsr	aff_sp
	bsr.s	_crlf
;	bsr.s	tab
	bsr	aff_pc
	bsr.s	space_tab
	bsr	aff_ccr
	bsr.s	_crlf
	bsr	aff_log_time
	bsr.s	_crlf
	rts
	
_crlf:
	lea	.crlf(pc),a1
	bsr	cconws_window
;	Cconws	.crlf(pc)
	rts
.crlf:
	dc.b	13,11,0
	even
	
tab:
	lea	.tab(pc),a1
	bsr	cconws_window	
;	Cconws	.tab(pc)
	rts
.tab:
	dc.b	9,0
	even

space_tab:
	lea	.space_tab(pc),a1
	bsr	cconws_window	
;	Cconws	.tab(pc)
	rts
.space_tab:
	dc.b	'       ',9,0
	even
	
aff_a:
	move.l	a0,-(sp)
	move.b	acca,d0
	move.b	#2,d1
	move.l	#.acca,a0
	bsr	convert_to_string
	move.l	(sp)+,a0
	lea	.acca_string(pc),a1
	bsr	cconws_window
	rts	
.acca_string:
	dc.b	'A  $'
.acca:
	dcb.b	2,0
	dc.b	0
	even

aff_b:
	move.l	a0,-(sp)
	move.b	accb,d0
	move.b	#2,d1
	move.l	#.accb,a0
	bsr	convert_to_string
	move.l	(sp)+,a0
	lea	.accb_string(pc),a1
	bsr	cconws_window
	rts	
.accb_string:
	dc.b	'B  $'
.accb:
	dcb.b	2,0
	dc.b	0
	even

aff_d:
	move.l	a0,-(sp)
	move.w	accd,d0
	move.b	#4,d1
	move.l	#.accd,a0
	bsr	convert_to_string
	move.l	(sp)+,a0
	lea	.accd_string(pc),a1
	bsr	cconws_window
	rts	
.accd_string:
	dc.b	'D  $'
.accd:
	dcb.b	4,0
	dc.b	0
	even

aff_x:
	move.l	a0,-(sp)
	move.w	ix,d0
	move.b	#4,d1
	move.l	#.ix,a0
	bsr	convert_to_string
	move.l	(sp)+,a0
	lea	.ix_string(pc),a1
	bsr	cconws_window
	rts	
.ix_string:
	dc.b	'X   $'
.ix:
	dcb.b	4,0
	dc.b	0
	even

aff_y:
	move.l	a0,-(sp)
	move.w	iy,d0
	move.b	#4,d1
	move.l	#.iy,a0
	bsr	convert_to_string
	move.l	(sp)+,a0
	lea	.iy_string(pc),a1
	bsr	cconws_window
	rts	
.iy_string:
	dc.b	'Y   $'
.iy:
	dcb.b	4,0
	dc.b	0
	even

aff_sp:
	move.l	a0,-(sp)
	move.w	_sp,d0
	move.b	#4,d1
	move.l	#.sp,a0
	bsr	convert_to_string
	move.l	(sp)+,a0
	lea	.sp_string(pc),a1
	bsr	cconws_window
	rts	
.sp_string:
	dc.b	'SP  $'
.sp:
	dcb.b	4,0
	dc.b	0
	even

aff_pc:
	move.l	a0,-(sp)
	move.w	_pc,d0
	move.b	#4,d1
	move.l	#.pc,a0
	bsr	convert_to_string
	move.l	(sp)+,a0
	lea	.pc_string(pc),a1
	bsr	cconws_window
	rts	
.pc_string:
	dc.b	'PC $'
.pc:
	dcb.b	4,0
	dc.b	0
	even
	
aff_ccr:
	move.l	a0,-(sp)
	move.b	_ccr,d0
	lea	.ccr(pc),a0
	move.l	#'    ',(a0)
	move.l	#'    ',4(a0)
	btst	#S,d0
	beq.s	.not_s
.s:
	move.b	#'S',7-S(a0)
.not_s:
	btst	#X,d0
	beq.s	.not_x
.x:
	move.b	#'X',7-X(a0)
.not_x:
	btst	#H,d0
	beq.s	.not_h
.h:
	move.b	#'H',7-H(a0)
.not_h:
	btst	#I,d0
	beq.s	.not_i
.i:
	move.b	#'I',7-I(a0)
.not_i:
	btst	#N,d0
	beq.s	.not_n
.n:
	move.b	#'N',7-N(a0)
.not_n:
	btst	#Z,d0
	beq.s	.not_z
.z:
	move.b	#'Z',7-Z(a0)
.not_z:
	btst	#V,d0
	beq.s	.not_v
.v:
	move.b	#'V',7-V(a0)
.not_v:
	btst	#C,d0
	beq.s	.not_c
.c:
	move.b	#'C',7-C(a0)
.not_c:
	move.l	(sp)+,a0
	lea	.ccr_string(pc),a1
	bsr	cconws_window
	rts
.ccr_string:
	dc.b	'CCR '
.ccr:
	dc.b	'SXHINZVC'
	dc.b	0
	even

aff_log_time:
	move.l	a0,-(sp)
	move.w	logical_time,d0
	move.b	#4,d1
	move.l	#.time_h,a0
	bsr	convert_to_string
	move.w	logical_time+2,d0
	move.b	#4,d1
	move.l	#.time_l,a0
	bsr	convert_to_string
	move.l	(sp)+,a0
	lea	.time_string(pc),a1
	bsr	cconws_window
	rts	
.time_string:
	dc.b	't  $'
.time_h:
	dcb.b	4,0
.time_l:
	dcb.b	4,0
	dc.b	0
	even

aff_dump:
; a0 : fentre
	move.w	#1,window.column(a0)
	move.w	#1,window.line(a0)
	move.w	_pc,d0
	tst.l	window.user_reserved(a0)
	beq.s	.from_pc
	move.l	window.user_reserved(a0),a1
	move.w	(a1),d0
.from_pc:
	move.w	window.down_x(a0),d6
	sub.w	window.up_x(a0),d6
	subq.w	#2,d6
	ble.s	.end_dump
	subq.w	#6,d6		; 6 caractres pour crire l'adresse
	ble.s	.end_dump
	move.w	window.down_y(a0),d7
	sub.w	window.up_y(a0),d7
	subq.w	#1,d7
	ble.s	.end_dump
	move.l	#memory,a2
	move.w	d6,d5
.one_line:
; crit adresse
	move.w	d0,-(sp)
	move.l	a0,-(sp)
	move.l	#.adress,a0
	move.b	#4,d1
	move.b	#'$',(a0)+
	bsr.s	convert_to_string
	move.l	(sp)+,a0
	move.l	#.adress,a1
	bsr	cconws_window
	move.l	#.space,a1
	bsr	cconws_window
	moveq	#0,d0
	move.w	(sp)+,d0
; affiche les octets correspondants
	move.w	d5,d6
.dump:
	subq.w	#3,d6
	blt.s	.end_line
	move.w	d0,-(sp)
	move.l	a0,-(sp)
	move.b	(a2,d0.l),d0
	move.b	#2,d1
	move.l	#.mem,a0
	move.b	#' ',(a0)+
	bsr.s	convert_to_string
	move.l	(sp)+,a0
	move.l	#.mem,a1
	bsr	cconws_window
	move.w	(sp)+,d0
	addq.w	#1,d0
	bra.s	.dump
.end_line:
	bsr	_crlf
	subq.w	#1,d7
	bgt.s	.one_line
.end_dump:
	rts
.space:
	dc.b	' ',0
	even
.adress:
	dcb.w	4,0
.mem:
	dcb.w	4,0
	
convert_to_string:
; a0 : adresse destination
; d0 : nb  convertir
; d1 : nb de chiffres
; ne modifie en plus que d2
	cmp.b	#2,d1
	bne.s	.quatre
.deux:
	move.b	d0,d2
	ror.b	#4,d2
	bsr.s	convert_hexa
	move.b	d0,1(a0)
	move.b	d2,d0
	bsr.s	convert_hexa
	move.b	d0,(a0)
	clr.b	2(a0)
	rts
.quatre:
	move.w	d0,d2
	ror.w	#4,d2
	bsr.s	convert_hexa
	move.b	d0,3(a0)
	move.b	d2,d0
	ror.w	#4,d2
	bsr.s	convert_hexa
	move.b	d0,2(a0)
	move.b	d2,d0
	ror.w	#4,d2
	bsr.s	convert_hexa
	move.b	d0,1(a0)
	move.b	d2,d0
	bsr.s	convert_hexa
	move.b	d0,(a0)
	clr.b	4(a0)
	rts
	
convert_hexa:
	and.b	#$f,d0
	cmp.b	#$a,d0
	blo.s	.num
	add.b	#'A'-$a,d0
	rts
.num:
	add.b	#'0',d0
	rts

	include	'window.s'
	
	include	'intrface.s'
	