;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;        Copyright 2001-2002 The Removers, all rights reserved.
;;         Copying is covered by the GNU General Public License.

;;    This program is free software; you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation; either version 2 of the License, or
;;    (at your option) any later version.

;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;;    GNU General Public License for more details.

; Interface pour le dsassembleur 68HC11

	DATA

edit_name:
	dc.w	21
	dc.l	enter_name
	dc.w	$ffff
	dc.w	68
	dc.l	nom_fichier
enter_name:
	asciiz	'Enter name: '
	even

edit_adress:
	dc.w	21
	dc.l	enter_adress
	dc.w	$ffff
	dc.w	4
	dc.l	adress_text
enter_adress:
	asciiz	'Enter adress (4 hex figures): '
	even	
adress_text:
	dcb.b	5
	even

edit_jump:
	dc.w	21
	dc.l	enter_jump
	dc.w	$ffff
	dc.w	4
	dc.l	jump_text
enter_jump:
	asciiz	'Jump to (4 hex figures): '
	even
jump_text:
	dcb.b	5
	even

this_info:
	dc.w	22
	dc.l	get_info
	dc.w	0
	dc.w	0
	dc.l	0
get_info:
; ceci est normalement interdit (caractres de controle)
	dc.b	'Motorola 68HC11 Disassembler & Debugger (Seb/The Removers)'
	dc.b	13,11
	dc.b	'Club Electronique et Robotique, ENS Lyon, Avril 2000'
	dc.b	13,11
	dc.b	'http://removers.atari.org/'
	dc.b	0
	even

win_trace:
;	dc.w	0,7,50,29
	dc.w	0,7,50,13
;	dc.w	0,7,50,11
	dc.w	$ffff
	dc.w	$0
	dc.l	trace_title
	dc.l	disassemble
	dc.w	1,1
	dc.w	$ffff
	dcb.w	4,0
trace_title:
	asciiz	'Trace'
	even
	
win_reg:
	dc.w	0,0,50,6
	dc.w	$0
	dc.w	$0
	dc.l	reg_title
	dc.l	aff_regs
	dc.w	1,1
	dc.w	$ffff
	dcb.w	4,0
reg_title:
	asciiz	'Registers'
	even
	
win_mem1:
;	dc.w	50,0,80,29
	dc.w	50,0,80,10
;	dc.w	50,0,80,5
	dc.w	$0
	dc.w	$0
	dc.l	mem_title
	dc.l	aff_dump
	dc.w	1,1
	dc.w	$ffff
	dcb.w	4,0
mem_title:
	asciiz	'Memory'
	even

win_mem2:
;	dc.w	50,0,80,29
	dc.w	50,11,80,20
;	dc.w	50,0,80,5
	dc.w	$0
	dc.w	$0
	dc.l	mem_title
	dc.l	aff_dump
	dc.w	1,1
	dc.w	$ffff
	dcb.w	4,0

win_dis:
	dc.w	0,14,50,20
;	dc.w	0,14,50,17
	dc.w	$0
	dc.w	$0
	dc.l	dis_title
	dc.l	disassemble
	dc.w	1,1
	dc.w	$ffff
	dcb.w	4,0
dis_title:
	asciiz	'Disassembly'
	even
	
interface:
; registers
	dc.l	win_reg
	dcb.w	4,0
; trace
	dc.l	win_trace
	dcb.w	4,0
; disassembly
	dc.l	win_dis
	dcb.w	4,0
; memory
	dc.l	win_mem2
	dcb.w	4,0
; memory
	dc.l	win_mem1
	dcb.w	4,0
; fin
	dc.l	0
