;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;        Copyright 2001-2002 The Removers, all rights reserved.
;;         Copying is covered by the GNU General Public License.

;;    This program is free software; you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation; either version 2 of the License, or
;;    (at your option) any later version.

;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;;    GNU General Public License for more details.

*******************
* Hardware 68HC11 *
*******************

C:	equ	0
V:	equ	1
Z:	equ	2
N:	equ	3
I:	equ	4
H:	equ	5
X:	equ	6
S:	equ	7

	BSS
	even
* Registre X
ix:
ixh:
	ds.b	1
ixl:
	ds.b	1
	even
* Registre Y
iy:
iyh:
	ds.b	1
iyl:
	ds.b	1
	even
* Registre D=A|B
accd:
acca:	
	ds.b	1
accb:	
	ds.b	1
	even
* Program Counter
_pc:
pch:
	ds.b	1
pcl:
	ds.b	1
	even
* Stack Pointer
_sp:
sph:
	ds.b	1
spl:
	ds.b	1
	even
* Condition Code Register SXHINZVC
_ccr:
	ds.b	1
	even	
* RAM+ROM (2^16 octets)
memory:
	ds.b	1<<16
; 2 mots longs en plus (pour la circularit)
	ds.l	2
	